<?php

use Tygh\Registry;
use Tygh\Session;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

if($mode == 'checkout')
{
   
    if($_SESSION['cart']['shipping_required'])
    {
  

        if(fn_smilepay_is_711c2cup_selected() )
        {

            if($_SESSION['edit_step']=='step_four')
            {

                if(!fn_smilepay_is_c2cup_emap_selected())
                {
                    fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,TEXT_ERROR_SMILEPAY_VALIDATE_711C2CUP_EMAP_NOT_SELECTED);
                    fn_redirect(fn_url('checkout.checkout').'&edit_step=step_three');
                }
            
            }
        }
        elseif(fn_smilepay_is_711c2cp_selected() )
        {
            if($_SESSION['edit_step']=='step_four')
            {

                if(!fn_smilepay_is_c2cp_emap_selected())
                {
                    fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,TEXT_ERROR_SMILEPAY_VALIDATE_711C2CUP_EMAP_NOT_SELECTED);
                    fn_redirect(fn_url('checkout.checkout').'&edit_step=step_three');
                }
            
            }
        }
        
    }
    

    
}
elseif($mode == 'complete')
{
    //711c2cup process
    if(!isset($_REQUEST['order_id']))
    {
        fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,TEXT_ERROR_SMILEPAY_VALIDATE_711C2CUP_SHIPPING_UNKNOW);
        return null;
    }
    $order_id = $_REQUEST['order_id'];
    $order_info = fn_get_order_info($_REQUEST['order_id']);

   
 
    if(fn_smilepay_is_711c2cup_selected($order_id))
    {

         if(fn_smilepay_is_emap_selected())  // check E-Map data
         {
                  
             $result=fn_smilepay_get_emap_result_data_from_session();
                
             $post_data = array(
                            "Dcvc" => trim($order_info['shipping'][0]['service_params']['dcvc']),
                            "Rvg2c"=>  trim($order_info['shipping'][0]['service_params']['rvg2c']),
                            "Pay_zg" => SMILEPAY_PAY_ZG_711C2CUP,
                            "Pay_gdry"=>'TW',
                            "Verify_key"=> trim($order_info['shipping'][0]['service_params']['verifykey']),
                            "Tel_number"=>$order_info['s_phone'],
                            "Mobile_number"=>$order_info['s_phone'],
                            'Pur_name' =>  mb_substr($order_info['s_lastname'] . $order_info['s_firstname'],0,5,"utf-8"),
                            "Email" =>$order_info['email'],
                            "Data_id"=>$order_id,
                            "Amount"=>intval(round($order_info['total'])),
                            "Roturl_status" =>'cscart4_3_5',
                            //"Roturl" => fn_url("payment_notification.return?payment=smilepay_711c2c&order_id=$order_id", AREA, 'current'),
                            
     //                      "Deadline_date" => date("Y/m/d",mktime(0,0,0,date("m"),date("d")+$LimitDay,date("Y"))),  
                            "Od_sob" =>$order_id,    
                            "C2cstore" =>$result['storeid'].'/'. $result['storename'].'/'.$result['storeaddress'],                            	
                        );
             
              $resultsmse=fn_smilepay_payment_process(SMILEPAY_API_URL, $post_data);
              $result=array_merge($resultsmse,$result); //merge data for output
              $shippdata =  $order_info['shipping'][0];
              //fill comment
              if($result['Status'] ==1)
              {
                
                $comment = sprintf(TEXT_SUCCESS_SMILEPAY_711C2CUP_COMMENT_FORMAT,$shippdata['shipping'],$post_data['Pur_name'],$post_data['Mobile_number'] ,$result['SmilePayNO'],$result['storeid'],$result['storename'],$result['storeaddress'], $result['SmilePayNO'],$shippdata['service_params']['dcvc'],$shippdata['service_params']['verifykey']);
                $usercomment = sprintf(TEXT_SUCCESS_SMILEPAY_711C2CUP_COMMENT_FRONT_FORMAT,$shippdata['shipping'],$post_data['Pur_name'],$post_data['Mobile_number'] , $result['storeid'],$result['storename'],$result['storeaddress']);

                fn_smilepay_fill_comment($order_id,$comment,0);
                fn_smilepay_fill_comment($order_id,$usercomment,1);

              }
              else
              {
                $comment =  sprintf(TEXT_ERROR_SMILEPAY_711C2CUP_BACKEND_FORMAT,$shippdata['shipping'], $result['Status'], $result['Desc']);
                $usercomment = sprintf(TEXT_ERROR_SMILEPAY_711C2CUP_FRONT_FORMAT,$shippdata['shipping']);
                fn_smilepay_fill_comment($order_id,$comment,0);
                fn_smilepay_fill_comment($order_id,$usercomment,1);
              }
              //clear data
              fn_smilepay_set_emapview_result_data_to_session($result);
              fn_smilepay_clear_emap_result_data_to_session();  // clear old data for run once

         }
         elseif(fn_smilepay_is_shipping_run())
         {
               $result=fn_smilepay_get_emapview_result_data_from_session();
         }
         else
         {
             $result['Status'] = -99;
             $result['Errdesc'] = TEXT_ERROR_SMILEPAY_VALIDATE_711C2CUP_SHIPPING_NOT_FIND;
             $comment =  sprintf(TEXT_ERROR_SMILEPAY_711C2CUP_BACKEND_FORMAT,$shippdata['shipping'],$result['Status'], $result['Desc']);
             $usercomment =sprintf(TEXT_ERROR_SMILEPAY_711C2CUP_FRONT_FORMAT,$shippdata['shipping']);
             fn_smilepay_fill_comment($order_id,$comment,0);
             fn_smilepay_fill_comment($order_id,$usercomment,1);
         }
               
         //view output data
         if($result['Status'] ==1)
         {
             Tygh::$app['view']->assign('smilepay_shipping_type',"711c2cup");
             Tygh::$app['view']->assign('smilepay_shipping_error',0);
             Tygh::$app['view']->assign('smilepay_Pur_name',mb_substr($order_info['s_lastname'] . $order_info['s_firstname'],0,5,"utf-8"));
             Tygh::$app['view']->assign('smilepay_Mobile_number',$order_info['s_phone']);
             Tygh::$app['view']->assign('smilepay_Storename',$result['storename']);
             Tygh::$app['view']->assign('smilepay_Storeaddress',$result['storeaddress']);
             Tygh::$app['view']->assign('smilepay_Storeid',$result['storeid']);
             Tygh::$app['view']->assign('smilepay_Amount',$result['Amount']);
         }
         else
         {
             Tygh::$app['view']->assign('smilepay_shipping_type',"711c2cup");
             Tygh::$app['view']->assign('smilepay_shipping_error',1);
         }
      
      

        //fn_smilepay_clear_emapview_result_data_to_session();
    }
   
}
