<?php
use Tygh\Http;
use Tygh\Registry;


  if (!defined('BOOTSTRAP')) { die('Access denied'); }

// Return from smse website
  if (defined('PAYMENT_NOTIFICATION')) {
    if ($mode == 'return') {
        $order_info = fn_get_order_info($_REQUEST['order_id'], true);
        $processor_data =fn_get_processor_data($order_info['payment_method']['payment_id'] );
        if(!isset( $processor_data))
        {
            echo "Processor_data get fail."; 
            exit;
        }

        $result = fn_smilepay_get_smse_result_data_after_payment();
     
        if(!$result)
        {
             exit("Get Roturl error.") ;
        }
        

        if( $result['Data_id'] != $_REQUEST['order_id'])
        {
            echo "Order_id error.";
            exit;
        }

        $order_id = $_REQUEST['order_id'];
        $smilepay_date = $result['Process_date']." ". $result['Process_time'];

        //$result['Amount']=intval(round($order_info['total']));
        
        if($result['Classif'] != SMILEPAY_CLASSIF_IBON && $result['Classif'] != SMILEPAY_CLASSIF_LIFEET)
        {
            exit("Classif error.") ; 
        }
        if($result['Amount'] != intval(round($order_info['total'])))
        {
            exit("Amount error."); 
        }

        $mid               = $processor_data['processor_params']['mid'];
        $mid_value         = trim($processor_data['processor_params']['midvalue']);
        $mid_smilepay      = $result['Mid_smilepay'];   

        
        if($mid == 'Y'){
           if(!fn_smilepay_midfun($mid_value,$result['Amount'],$result['Smseid'],$mid_smilepay)){
              echo  "Possible fraud";
              exit();
          }
        }    

        $comment=sprintf(TEXT_SUCCESS_SMILEPAY_COMMON_PAID_COMMENT_FORMAT, $result['Smseid'],  $smilepay_date );
        $usercomment=sprintf(TEXT_SUCCESS_SMILEPAY_COMMON_PAID_COMMENT_FRONT_FORMAT, $smilepay_date );
        fn_smilepay_fill_comment($order_id,$comment,0);
        fn_smilepay_fill_comment($order_id,$usercomment,1);
        $notifyforce = array(
                        'C'=>true,
                        'A'=>true,
                       );
                       
        $pp_response['order_status']='P';
        $pp_response["reason_text"]=$comment;
        
       // fn_change_order_status($order_id,$pp_response['order_status'],'',$notifyforce);
        fn_finish_payment( $order_id, $pp_response,$notifyforce);

      //  fn_order_notification($order_info,array(),$notifyforce);
        
        echo "<Roturlstatus>cscart4_3_5</Roturlstatus>";
    }
   

  }
  else
  {
      //smilepay param validation
     if(!isset($processor_data['processor_params']['dcvc']) || !isset($processor_data['processor_params']['verifykey']) 
        || empty($processor_data['processor_params']['dcvc'])|| empty($processor_data['processor_params']['verifykey'])
        || !isset($processor_data['processor_params']['rvg2c']) || $processor_data['processor_params']['rvg2c']=="")
     {
         fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,TEXT_ERROR_SMILEPAY_VALIDATE_BACKEND_SETTING);
         fn_order_placement_routines('checkout_redirect');
     }

     foreach ($order_info['products'] as $product) {
      		$products .=   $product['product'].", ";
     }
     $products = substr($products,0,count($products)-3);
     $_od_sob =   mb_substr($products,0,15,'utf-8');

     fn_smilepay_clear_smse_result_data_to_session();

     /*$LimitDay=$processor_data['processor_params']['dayline'] ;
     if ($LimitDay=="" || (!is_numeric($LimitDay))){
          $LimitDay=6    ;
     };*/  
     $post_data= array(
            "Dcvc" =>  trim($processor_data['processor_params']['dcvc']),
            "Rvg2c"=>   trim($processor_data['processor_params']['rvg2c']),
            "Pay_zg" => SMILEPAY_PAY_ZG_IBON,
            "Pay_gdry"=>'TW',
            "Verify_key"=> trim($processor_data['processor_params']['verifykey']),
            "Tel_number"=>$order_info['b_phone'],
            "Mobile_number"=>$order_info['b_phone'],
            "Email" =>$order_info['email'],
            "Data_id"=>$order_id,
            "Amount"=>intval(round($order_info['total'])),
            "Roturl_status" =>'cscart4_3_5',
            "Roturl" => fn_url("payment_notification.return?payment=smilepay_ibon&order_id=".$order_id, AREA, 'current'),
           // "Deadline_date" => date("Y/m/d",mktime(0,0,0,date("m"),date("d")+$LimitDay,date("Y"))),  
            "Od_sob" => $_od_sob ,
            "Pur_name" =>  $order_info['b_lastname'].$order_info['b_firstname'],                          	
         );
      

     $result=fn_smilepay_payment_process(SMILEPAY_API_URL, $post_data);

     if($result['Status']!=1)
     {
         
          $comment =  sprintf(TEXT_ERROR_SMILEPAY_BACKEND_FORMAT,$order_info['payment_method']['payment'],$result['Status'], $result['Desc']);
          $usercomment = sprintf(TEXT_ERROR_SMILEPAY_FRONT_FORMAT,$order_info['payment_method']['payment']);

          $pp_response['order_status']='F';
          $pp_response["reason_text"]=$comment;
          $notifyforce = array(
                        'C'=>true,
                        'A'=>true,
                       );
          fn_change_order_status( $order_id,$pp_response['order_status']);
          fn_update_order_payment_info($order_id,$pp_response);

          //write error comment for admin
          fn_smilepay_fill_comment($order_id,$comment,0);
          fn_smilepay_fill_comment($order_id,$usercomment,1);
          //set error notification
          fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,$usercomment);
          fn_order_placement_routines('checkout_redirect');
                  
      }
      else
      {
           $comment= sprintf(TEXT_SUCCESS_SMILEPAY_IBON_COMMENT_FORMAT,$result['SmilePayNO'],$result['IbonNo'],$result['Amount'],urldecode($result['PayEndDate']));
           $usercomment= sprintf(TEXT_SUCCESS_SMILEPAY_IBON_COMMENT_FRONT_FORMAT,$result['IbonNo'],$result['Amount'],urldecode($result['PayEndDate']));

           $pp_response['order_status']='O';
           $pp_response["reason_text"]=$comment;
           $notifyforce = array(
                        'C'=>true,
                        'A'=>true,
                       );
           fn_change_order_status( $order_id,$pp_response['order_status'],'',$notifyforce);
           fn_update_order_payment_info($order_id,$pp_response);

           fn_smilepay_fill_comment($order_id,$comment,0);
           fn_smilepay_fill_comment($order_id,$usercomment,1);

           fn_smilepay_set_smse_result_data_to_session($result);
         
           fn_order_placement_routines('route',$order_id);
       }
        
  
       // fn_clear_cart($cart, false,true);
      //  echo "return";
  }
  exit;
?>