<?php
use Tygh\Http;
use Tygh\Registry;


  if (!defined('BOOTSTRAP')) { die('Access denied'); }

// Return from smse website
  if (defined('PAYMENT_NOTIFICATION')) {
    if ($mode == 'return') {

        $order_info = fn_get_order_info($_REQUEST['order_id'], true);
        $processor_data =fn_get_processor_data($order_info['payment_method']['payment_id'] );
        if(!isset( $processor_data))
        {
            echo "Processor_data get fail."; 
            exit;
        }
        $result = array();
        $result = fn_smilepay_get_smse_result_data_after_payment();//payment
     
        if(!$result)
        {
             exit("Get Roturl error.") ;
        }
        

        if( $result['Data_id'] != $_REQUEST['order_id'])
        {
            echo "Order_id error.";
            exit;
        }

        $order_id = $_REQUEST['order_id'];
        $smilepay_date =  $result['Process_date']." ". $result['Process_time'];
       
        /*if(SMILEPAY_DEBUG)
        {
           $result['Amount']=intval(round($order_info['total']));
        }*/
      //$result['Amount']=intval(round($order_info['total']));



        if($result['Classif'] != SMILEPAY_CLASSIF_711C2CP)
        {
            exit("Classif error.") ; 
        }
        if($result['Amount'] != intval(round($order_info['total'])))
        {
            exit("Amount error."); 
        }

        $mid               = $processor_data['processor_params']['mid'];
        $mid_value         = trim($processor_data['processor_params']['midvalue']);
        $mid_smilepay      = $result['Mid_smilepay'];   

        
        if($mid == 'Y'){
           if(!fn_smilepay_midfun($mid_value,$result['Amount'],$result['Smseid'],$mid_smilepay)){
               
              echo  "Possible fraud";
              exit();
          }
        }    

   
        $comment=sprintf(TEXT_SUCCESS_SMILEPAY_711C2C_PAID_COMMENT_FORMAT, $result['Smseid'],  $smilepay_date );
        $usercomment=sprintf(TEXT_SUCCESS_SMILEPAY_711C2C_PAID_COMMENT_FRONT_FORMAT, $smilepay_date );
        fn_smilepay_fill_comment($order_id,$comment,0);
        fn_smilepay_fill_comment($order_id,$usercomment,1);

        $notifyforce = array(
                        'C'=>true,
                        'A'=>true,
                       );

      
        //fn_order_notification($order_info,array(),$notifyforce);

        $pp_response['order_status']='C';
        $pp_response["reason_text"]=$comment;
        fn_finish_payment( $order_id, $pp_response,$notifyforce);
        
        echo "<Roturlstatus>cscart4_3_5</Roturlstatus>";
    }else if($mode == 'mapreturn')
    {
     //  echo "mapreturn cscart4_3_5.";
    //   echo $_REQUEST['Pur_name'];
   
        if( $_REQUEST['Data_id'] != $_REQUEST['order_id'])
        {
            
            echo "Order_id error.";
            exit;
        }
     
       $result = fn_smilepay_get_smse_shipping_result_data_after_payment(); //get shipping data

       $pp_response['order_status']='O';
       $pp_response["reason_text"]=TEXT_SMIMEPAY_ORDER_CREATED_SUCCESSFUL;
       $notifyforce = array(
                        'C'=>true,
                        'A'=>true,
                       );

       fn_smilepay_set_smse_shipping_result_data_to_session($result);
       $order_id=$_REQUEST['order_id'];
        
       $order_info = fn_get_order_info($_REQUEST['order_id'], true);
       $processor_data = fn_get_processor_data($order_info['payment_method']['payment_id'] );

       if($_REQUEST['Amount'] ==0 || intval(round($order_info['total']))!= $_REQUEST['Amount'])
       {
           //amount error
            $pp_response['order_status']='F';
            $pp_response["reason_text"]=TEXT_ERROR_SMILEPAY_AMOUNT;
            $comment=TEXT_ERROR_SMILEPAY_AMOUNT;
            fn_smilepay_fill_comment($order_id,$comment,0);
            fn_change_order_status( $order_id,$pp_response['order_status'],'',$notifyforce);
            fn_update_order_payment_info($order_id,$pp_response);
            fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,$comment);
            fn_order_placement_routines('checkout_redirect');
       }

       $comment = sprintf(TEXT_SUCCESS_SMILEPAY_711C2C_COMMENT_FORMAT, $result['Smseid'],$result['Pur_name'],$result['Mobile_number'],$result['Amount'],$result['Storeid'],$result['Storename'],$result['Storeaddress'], $result['Smseid'],$processor_data['processor_params']['dcvc'],$processor_data['processor_params']['verifykey']);
       $usercomment = sprintf(TEXT_SUCCESS_SMILEPAY_711C2C_COMMENT_FRONT_FORMAT, $result['Pur_name'],$result['Mobile_number'],$result['Amount'],$result['Storeid'],$result['Storename'],$result['Storeaddress']);
       fn_change_order_status( $order_id,$pp_response['order_status'],'',$notifyforce);
       fn_update_order_payment_info($order_id,$pp_response);

       fn_smilepay_fill_comment($order_id,$comment,0);
       fn_smilepay_fill_comment($order_id,$usercomment,1);

 
       fn_order_placement_routines('route', $order_id);
     }
      

  }
  else
  {

     if(!isset($order_info['b_phone']) || !preg_match("/^[0][9][0-9]{8,8}/",$order_info['b_phone']))
     {
         fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,TEXT_ERROR_SMILEPAY_VALIDATE_PHONE);
         fn_order_placement_routines('checkout_redirect');
     }

     if( !isset($order_info['b_lastname'])|| !isset($order_info['b_firstname']) ||  (mb_strlen($order_info['b_lastname'].$order_info['b_firstname']) >5) )
     {
         
         fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,TEXT_ERROR_SMILEPAY_VALIDATE_NAME);
         fn_order_placement_routines('checkout_redirect');
     }
     if(!isset($processor_data['processor_params']['dcvc']) || !isset($processor_data['processor_params']['verifykey']) 
        || empty($processor_data['processor_params']['dcvc'])|| empty($processor_data['processor_params']['verifykey']) 
        || !isset($processor_data['processor_params']['rvg2c']) || $processor_data['processor_params']['rvg2c']=="")
     {
         fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,TEXT_ERROR_SMILEPAY_VALIDATE_BACKEND_SETTING);
         fn_order_placement_routines('checkout_redirect');
     }
     
    
     if(!isset($order_info['total']) || $order_info['total']<SMILEPAY_PAY_MIN_PRICE_711C2C || $order_info['total']>SMILEPAY_PAY_MAX_PRICE_711C2C  )
     {
         fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,TEXT_ERROR_SMILEPAY_VALIDATE_711C2C_PRICE);
         fn_order_placement_routines('checkout_redirect');
     }

     foreach ($order_info['products'] as $product) {
      		$products .=   $product['product'].", ";
     }
     $products = substr($products,0,count($products)-3);
     $_od_sob =   mb_substr($products,0,15,'utf-8');

     $emap_result = fn_smilepay_get_emap_result_data_from_session();

     if(!fn_smilepay_is_c2cp_emap_selected())
     {
         fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,TEXT_ERROR_SMILEPAY_VALIDATE_711C2CUP_EMAP_NOT_SELECTED);
         fn_order_placement_routines('checkout_redirect');
     }



     fn_smilepay_clear_smse_result_data_to_session();

     /*$LimitDay=$processor_data['processor_params']['dayline'] ;
     if ($LimitDay=="" || (!is_numeric($LimitDay))){
          $LimitDay=6    ;
     };*/  
    /*
     $post_data= array(
            "Dcvc" =>  trim($processor_data['processor_params']['dcvc']),
            "Rvg2c"=>   trim($processor_data['processor_params']['rvg2c']),
            "Pay_zg" => SMILEPAY_PAY_ZG_711C2C,
            "Pay_gdry"=>'TW',
            "Verify_key"=> trim($processor_data['processor_params']['verifykey']),
            "Tel_number"=>$order_info['b_phone'],
            "Mobile_number"=>$order_info['b_phone'],
            'Pur_name' =>  mb_substr($order_info['b_lastname'] . $order_info['b_firstname'],0,5,"utf-8"),
            "Email" =>$order_info['email'],
            "Data_id"=>$order_id,
            "Amount"=>intval(round($order_info['total'])),
            "Roturl_status" =>'cscart4_3_5',
            "Roturl" => fn_url("payment_notification.return?payment=smilepay_711c2c&order_id=$order_id", AREA, 'current'),
            'MapRoturl' => fn_url("payment_notification.mapreturn?payment=smilepay_711c2c&order_id=".$order_id, AREA, 'current'),
     //       "Deadline_date" => date("Y/m/d",mktime(0,0,0,date("m"),date("d")+$LimitDay,date("Y"))),  
            "Od_sob" => $_od_sob ,                                	
         );
         fn_create_payment_form(SMILEPAY_EZPOS_URL, $post_data, 'smilepay_711c2c', false);
      */

    

      $post_data= array(
            "Dcvc" =>  trim($processor_data['processor_params']['dcvc']),
            "Rvg2c"=>   trim($processor_data['processor_params']['rvg2c']),
            "Pay_zg" => SMILEPAY_PAY_ZG_711C2C,
            "Pay_gdry"=>'TW',
            "Verify_key"=> trim($processor_data['processor_params']['verifykey']),
            "Tel_number"=>$order_info['b_phone'],
            "Mobile_number"=>$order_info['b_phone'],
            'Pur_name' =>  mb_substr($order_info['b_lastname'] . $order_info['b_firstname'],0,5,"utf-8"),
            "Email" =>$order_info['email'],
            "Data_id"=>$order_id,
            "Amount"=>intval(round($order_info['total'])),
            "Roturl_status" =>'cscart4_3_5',
            "Roturl" => fn_url("payment_notification.return?payment=smilepay_711c2c&order_id=$order_id", AREA, 'current'),
            "Logistics_store" => $emap_result['storeid'].'/'. $emap_result['storename'].'/'.$emap_result['storeaddress'], 
     //       "Deadline_date" => date("Y/m/d",mktime(0,0,0,date("m"),date("d")+$LimitDay,date("Y"))),  
            "Od_sob" => $_od_sob ,                                	
         );

         
      $result = fn_smilepay_shipping_process(SMILEPAY_API_URL, $post_data);
      $result = array_merge($emap_result,$result); //merge data for output
      $result['Pur_name'] = $post_data['Pur_name'];
      $result['Mobile_number'] = $post_data['Mobile_number'];
      if($result['Status']!=1)
      {
         
          $comment =  sprintf(TEXT_ERROR_SMILEPAY_BACKEND_FORMAT,$order_info['payment_method']['payment'],$result['Status'], $result['Desc']);
          $usercomment = sprintf(TEXT_ERROR_SMILEPAY_FRONT_FORMAT,$order_info['payment_method']['payment']);

          $pp_response['order_status']='F';
          $pp_response["reason_text"]=$comment;
          $notifyforce = array(
                        'C'=>true,
                        'A'=>true,
                       );
          fn_change_order_status( $order_id,$pp_response['order_status']);
          fn_update_order_payment_info($order_id,$pp_response);

          //write error comment for admin
          fn_smilepay_fill_comment($order_id,$comment,0);
          fn_smilepay_fill_comment($order_id,$usercomment,1);
          //set error notification
          fn_set_notification('E',TEXT_ERROR_SMILEPAY_MESSAGE_TITLE,$usercomment);
          fn_order_placement_routines('checkout_redirect');
                  
      }
      else
      {
          $pp_response['order_status']='O';
          $pp_response["reason_text"]=TEXT_SMIMEPAY_ORDER_CREATED_SUCCESSFUL;
          $notifyforce = array(
                        'C'=>true,
                        'A'=>true,
                       );
          $comment = sprintf(TEXT_SUCCESS_SMILEPAY_711C2C_COMMENT_FORMAT, $result['SmilePayNO'],$result['Pur_name'],$result['Mobile_number'],$result['Amount'],$result['storeid'],$result['storename'],$result['storeaddress'], $result['SmilePayNO'],$processor_data['processor_params']['dcvc'],$processor_data['processor_params']['verifykey']);
          $usercomment = sprintf(TEXT_SUCCESS_SMILEPAY_711C2C_COMMENT_FRONT_FORMAT, $result['Pur_name'],$result['Mobile_number'],$result['Amount'],$result['storeid'],$result['storename'],$result['storeaddress']);
          fn_change_order_status( $order_id,$pp_response['order_status'],'',$notifyforce);
          fn_update_order_payment_info($order_id,$pp_response);

          fn_smilepay_fill_comment($order_id,$comment,0);
          fn_smilepay_fill_comment($order_id,$usercomment,1);

          fn_smilepay_set_smse_shipping_result_data_to_session($result);
          fn_smilepay_clear_emap_result_data_to_session();  // clear old data for run once
           
          fn_order_placement_routines('route', $order_id);
       }


    

  }
  exit;
?>